# Gorod Krovi Valve Solver
During the Easter Egg of the Call of Duty: Black Ops 3 Zombies map *Gorod Krovi*, we need to solve one step that
requires connecting all the valves so that the air can flow from the green-lit valve to the valve containing the
cylinder.

Each valve is connected to three other valves as shown in the following image.

![Valve Connections](/resources/gk-valves.png)

We can view the valves as an *Undirected Graph* and the solution is to find a [Hamiltonian Path](https://en.wikipedia.org/wiki/Hamiltonian_path)
(i.e: the path that visits each vertex exactly once) starting from the green-lit valve and finishing at the valve
that contains the cylinder.

## Installation
This package can be installed with `pip`.

```
pip install --upgrade gkvalves
```

## Usage
Use the `list` subcommand to list all the available locations.

```
(0) Armory
(1) Department Store
(2) Dragon Command
(3) Supply Depot
(4) Infirmary
(5) Tank Factory
```

Use the `solve` subcommand to find a configuration that communicates all the valves. You must supply the location
id (number between 0-5) of the green-lit valve and the valve that contains the cylinder.

```
# Find configuration for Armory (green) -> Department Store (cylinder)
$ gkvalves solve 0 1

Armory: 1
Department Store: This is the ending valve.
Dragon Command: 2
Supply Depot: 3
Infirmary: 3
Tank Factory: 1
```
